package io.xjar;

import org.apache.commons.compress.archivers.jar.JarArchiveEntry;
import java.io.File;
import io.xjar.key.XKey;

public class XCryptos extends XFilters implements XConstants
{
    public static XEncryption encryption() {
        return new XEncryption();
    }
    
    public static XDecryption decryption() {
        return new XDecryption();
    }
    
    public static void encrypt(final String src, final String dest, final XKey xKey) throws Exception {
        encrypt(new File(src), new File(dest), xKey);
    }
    
    public static void encrypt(final File src, final File dest, final XKey xKey) throws Exception {
        final XSmartEncryptor xSmartEncryptor = new XSmartEncryptor(new XJdkEncryptor());
        xSmartEncryptor.encrypt(xKey, src, dest);
    }
    
    public static void encrypt(final String src, final String dest, final XKey xKey, final XEntryFilter<JarArchiveEntry> filter) throws Exception {
        encrypt(new File(src), new File(dest), xKey, filter);
    }
    
    public static void encrypt(final File src, final File dest, final XKey xKey, final XEntryFilter<JarArchiveEntry> filter) throws Exception {
        final XSmartEncryptor xSmartEncryptor = new XSmartEncryptor(new XJdkEncryptor(), filter);
        xSmartEncryptor.encrypt(xKey, src, dest);
    }
    
    public static void encrypt(final String src, final String dest, final String password) throws Exception {
        encrypt(src, dest, XKit.key(password));
    }
    
    public static void encrypt(final File src, final File dest, final String password) throws Exception {
        encrypt(src, dest, XKit.key(password));
    }
    
    public static void encrypt(final String src, final String dest, final String password, final XEntryFilter<JarArchiveEntry> filter) throws Exception {
        encrypt(src, dest, XKit.key(password), filter);
    }
    
    public static void encrypt(final File src, final File dest, final String password, final XEntryFilter<JarArchiveEntry> filter) throws Exception {
        encrypt(src, dest, XKit.key(password), filter);
    }
    
    public static void decrypt(final String src, final String dest, final XKey xKey) throws Exception {
        decrypt(new File(src), new File(dest), xKey);
    }
    
    public static void decrypt(final File src, final File dest, final XKey xKey) throws Exception {
        final XSmartDecryptor xSmartDecryptor = new XSmartDecryptor(new XJdkDecryptor());
        xSmartDecryptor.decrypt(xKey, src, dest);
    }
    
    public static void decrypt(final String src, final String dest, final XKey xKey, final XEntryFilter<JarArchiveEntry> filter) throws Exception {
        decrypt(new File(src), new File(dest), xKey, filter);
    }
    
    public static void decrypt(final File src, final File dest, final XKey xKey, final XEntryFilter<JarArchiveEntry> filter) throws Exception {
        final XSmartDecryptor xSmartDecryptor = new XSmartDecryptor(new XJdkDecryptor(), filter);
        xSmartDecryptor.decrypt(xKey, src, dest);
    }
    
    public static void decrypt(final String src, final String dest, final String password) throws Exception {
        decrypt(src, dest, XKit.key(password));
    }
    
    public static void decrypt(final File src, final File dest, final String password) throws Exception {
        decrypt(src, dest, XKit.key(password));
    }
    
    public static void decrypt(final String src, final String dest, final String password, final XEntryFilter<JarArchiveEntry> filter) throws Exception {
        decrypt(src, dest, XKit.key(password), filter);
    }
    
    public static void decrypt(final File src, final File dest, final String password, final XEntryFilter<JarArchiveEntry> filter) throws Exception {
        decrypt(src, dest, XKit.key(password), filter);
    }
}
